<?php

/**
 * The admin-specific functionality of the plugin.
 *
 * @link       https://www.wpdispensary.com/
 * @since      1.0.0
 *
 * @package    WPD_Inventory
 * @subpackage WPD_Inventory/admin
 */

/**
 * Out of Stock message.
 *
 * @param string $content
 * @return string
 */
function wpd_out_of_stock_content( $content ) {
	global $post;

	// Set default content.
	$default_content = $content;

	/**
	 * Defining variables
	 */
	$original  = '';
	$post_type = get_post_type_object( get_post_type( $post ) );

	/**
	 * Adding the WP Dispensary out of stock data
	 */
	if ( in_array( get_post_type(), array( 'products' ) ) ) {
		$original = $content;
	} else {
		$original = '';
	}

	if ( in_array( get_post_type(), array( 'products' ) ) ) {
		$content = '';
	} else {
		$content = $content;
	}

	// Flowers.
	if ( is_singular( 'products' ) ) {
		$product_type = get_post_meta( get_the_ID(), 'product_type', true );
		// Out of stock message.
		if ( 'flowers' == $product_type && ! get_post_meta( get_the_ID(), 'inventory_grams', true ) ) {
			$content .= '<div class="wpd-inventory ' . $product_type . ' warning">';
			$content .= '<p>' . __( 'Sorry, this flower is currently out of stock.', 'wpd-ecommerce' ) . '</p>';
			$content .= '</div>';
		}
	}

	/**
	 * Display the out of stock message
	 */
	$content .= $original;

	// eCommerce plugin check.
	if ( ! is_plugin_active( 'wpd-ecommerce/wpd-ecommerce.php' ) ) {
		$content = $content;
	} else {
		$content = $default_content;
	}

	return $content;
}
add_filter( 'the_content', 'wpd_out_of_stock_content' );
